float get_radius(int r) {

  int min_count = 1;
  int max_count = 10000000;
  float min_r = 0.0;
  float max_r = 300.0;

  float get_r = map(r, min_count, max_count, min_r, max_r);

  return get_r;
}


float get_theta(int day_of_week) {

  float[] theta_array = new float[7];
  for (int i = 0; i < week; i++) {
    theta_array[i] = (week-i)*TWO_PI/7;
  }

  return theta_array[day_of_week];
}


float get_z(int num_followers) {

  int min_count = 1;
  int max_count = 10000000;
  float min_r = 5.0;
  float max_r = 800.0;

  float get_followers = map(num_followers, min_count, max_count, min_r, max_r);

  return get_followers;
}

// control color
// damaku -> color: convert function 
float get_color_scale(int danmaku, String video_class) {

  if (video_class.equals("Game")) {
    min_count = 19;
    max_count = 319288;
  } else if (video_class.equals("Music")) {
    min_count = 259;
    max_count = 45046;
  } else if (video_class.equals("Animation")) {
    min_count = 33;
    max_count = 117638;
  } else if (video_class.equals("Dance")) {
    min_count = 5;
    max_count = 33105;
  } else if (video_class.equals("Technology")) {
    min_count = 0;
    max_count = 205163;
  } else if (video_class.equals("Digital")) {
    min_count = 15;
    max_count = 260820;
  } else if (video_class.equals("Life")) {
    min_count = 206;
    max_count = 766317;
  } else if (video_class.equals("Fashion")) {
    min_count = 124;
    max_count = 181861;
  } else if (video_class.equals("Autotune_Remix")) {
    min_count = 34;
    max_count = 123228;
  }

  float min_color = 100.0;
  float max_color = 255.0;
  // the video had more bullet comments, the color should be darker -> the opacity of the stroke should be higher
  float get_color = map(danmaku, min_count, max_count, min_color, max_color);

  return get_color;
}

// control width
// share -> width: convert function 
float get_width_scale(int share, String video_class) {

  if (video_class.equals("Game")) {
    min_count = 16;
    max_count = 110103;
  } else if (video_class.equals("Music")) {
    min_count = 116;
    max_count = 67392;
  } else if (video_class.equals("Animation")) {
    min_count = 51;
    max_count = 332774;
  } else if (video_class.equals("Dance")) {
    min_count = 1;
    max_count = 61138;
    min_width = 2.0;
    max_width = 4.0;
  } else if (video_class.equals("Technology")) {
    min_count = 1;
    max_count = 353319;
  } else if (video_class.equals("Digital")) {
    min_count = 16;
    max_count = 416392;
    min_width = 2.0;
    max_width = 4.0;
  } else if (video_class.equals("Life")) {
    min_count = 86;
    max_count = 148684;
  } else if (video_class.equals("Fashion")) {
    min_count = 28;
    max_count = 179684;
  } else if (video_class.equals("Autotune_Remix")) {
    min_count = 27;
    max_count = 424017;
  }

  float min_width = 0.9;
  float max_width = 4.0;
  // the video had more shares, the width should be wider
  float get_width = map(share, min_count, max_count, min_width, max_width);

  return get_width;
}


// create color hashmap
void create_clr_map() {

  for (int i = 0; i < 9; i++) {
    clr_map.put(class_names[i], clr[i]);
  }
}
